import org.apache.log4j.Logger;
import org.apache.log4j.Level;
import org.apache.commons.exec.ExecuteWatchdog;
import org.springframework.stereotype.Service;

import java.io.*;
import java.util.Properties;

/**
 * User: Vivek Krishnan
 * Date: 28/05/13
 */
@Service("accountService")
public class AccountServiceImpl implements AccountService {
    Properties configProperties = new Properties();

    public boolean createUserAccount(String userId, SignUpDataValue signUpData, String password) {
        StringBuilder powerShellCommand = new StringBuilder();
        String responseCode = null;

        try {
            configProperties.load(this.getClass().getClassLoader().getResourceAsStream("powerShellDetails.properties"));
            String newUserScriptPath = configProperties.getProperty("NEWUSER_SCRIPT_PATH");
            powerShellCommand.append("powershell -command \"&{" + newUserScriptPath);
            powerShellCommand.append(" -sam '" + userId);
            powerShellCommand.append("' -firstnames '" + signUpData.getForname());
            powerShellCommand.append("' -Surname '" + signUpData.getSurname());
            powerShellCommand.append("' -Password '" + password);
            powerShellCommand.append("'; exit $LastExitCode }\"");

            System.out.println("PowerShell = " + powerShellCommand.toString());

            ExecuteWatchdog watchdog = new ExecuteWatchdog(5000);
            Process powerShellProcess = Runtime.getRuntime().exec(powerShellCommand.toString());
            if (watchdog != null) {
                watchdog.start(powerShellProcess);
            }

            BufferedReader stdInput = new BufferedReader(new InputStreamReader(powerShellProcess.getErrorStream()));
            PrintWriter out = new PrintWriter(powerShellProcess.getOutputStream());
            String outline = new String();

            out.write(outline);
            out.flush();
        } catch (IOException ex) {
            Logger.getLogger(AccountServiceImpl.class.getName()).log(Level.FATAL, null, ex);

        }

        return true;
    }
}